<?php
/*
Developer Formater
http://wordpress.org/extend/plugins/devformatter/
Developer Formatter system to WordPress. Powered by <a href="http://qbnz.com/highlighter/">GeSHi</a> server-side highlight system.
Version: 2009.0.1.21
Author: Gilberto Saraiva
Author URI: http://gsaraiva.projects.pro.br/

Copyright (c) 2009 Gilberto Saraiva
Released under the GNU General Public License (GPL)
http://www.gnu.org/licenses/gpl.txt
*/

  require_once(DEVFMT_PATH.'geshi'.DIRECTORY_SEPARATOR.'geshi.php');

  $DevFmt_Config = Array();
  $DevFmt_SuppLangs = Array();
  $DevFmt_FiltersToAvoid = Array("wptexturize", "wpautop", "force_balance_tags");

  function devfmt_Version($AVersion = ""){
    if($AVersion != ""){
      $verData = explode(".", $AVersion);
      $verTotal = 0;
      for($i = 0; $i < Count($verData); $i++){
        $verTotal *= 1000;
        $verTotal += $verData[$i];
      }
      return $verTotal;
    }else{
      return "2009.0.1.20";
    }
  }

  function devfmt_DefaultPublicCSS(){
    return "  .devcode, .devcodelines, .devcodeblock, .devcodetools {
    padding: 0;
    margin: 0;
    font-size: 12px;
    font-family: courier new;
  }
  .devcode {
    padding: 0px 5px;
    color: #000;
  }
  .devcodeoverflow {
    margin: 1px;
    overflow: auto;
    overflow-x: auto;
    overflow-y: auto;
  }
  .devcodelines {
    padding-left: 5px;
    padding-right: 5px;
    background: #888;
    color: #fff;
    border-right: 4px solid #6E6;
  }
  .devcodelinesodd {
    background: #999;
  }
  .devcodelinesarea {
    background: #fff;
  }
  .devcodelinesareaodd {
    background: #f0f0f0;
  }
  .devcodetools {
    background: transparent;  
    color: #888;
    text-align: left;
  }
  .devcodetools span {
    cursor: pointer;
  }";
  }
  $DevFmt_DefaultPublicCSS = devfmt_DefaultPublicCSS();

  function devfmt_DefaultPublicCSSBlue(){
    return "  .devcode, .devcodelines, .devcodeblock, .devcodetools {
    padding: 0;
    margin: 0;
    font-size: 12px;
    font-family: courier new;
  }
  .devcode {
    padding: 0px 5px;
    color: #000;
    border: 1px solid #5A9AC0;
  }
  .devcodeline {
    border: 0px;
  }
  .devcodeoverflow {
    margin: 1px;
    overflow: auto;
    overflow-x: auto;
    overflow-y: auto;
  }
  .devcodelines {
    padding-left: 5px;
    padding-right: 5px;
    background: #729EB9;
    color: #fff;
    border-right: 4px solid #6E6;
  }
  .devcodelinesodd {
    background: #628EA9;
  }
  .devcodelinesarea {
    background: #fff;
  }
  .devcodelinesareaodd {
    background: #f0f0f0;
  }
  .devcodetools {
    background: transparent;  
    color: #000;
    text-align: left;
  }
  .devcodetools span {
    cursor: pointer;
  }";
  }
  $DevFmt_DefaultPublicCSSBlue = devfmt_DefaultPublicCSSBlue();

  function devfmt_ReadConfig(){
    GLOBAL $DevFmt_Config, $DevFmt_SuppLangs, $table_prefix, $wpdb;
    $DevFmt_Config = $wpdb->get_row("SELECT * FROM `{$table_prefix}devfmt_config`", ARRAY_A);
    unset($DevFmt_Config["devversion"]);
  }

  function devfmt_UpdateConfig(){
    GLOBAL $DevFmt_Config, $table_prefix, $wpdb;

    $SET = array();
    foreach($DevFmt_Config as $Field => $Value)
      $SET[] = "`$Field`='$Value'";
    $wpdb->query("update `{$table_prefix}devfmt_config` set ".implode(",", $SET).";");
    devfmt_ReadConfig();
  }

  function devfmt_ReadSupportedLangs(){
    GLOBAL $DevFmt_Config, $DevFmt_SuppLangs, $table_prefix, $wpdb;
    $DevFmt_SuppLangs = $wpdb->get_results("SELECT * FROM `{$table_prefix}devfmt_supplangs`", ARRAY_A);
  }

  function devfmt_UpdateSupportedLangs(){
    GLOBAL $DevFmt_Config, $DevFmt_SuppLangs, $table_prefix, $wpdb;

    $NewSuppLangs = Array();
    if($dh = opendir($DevFmt_Config['geshilangpath']))
      while(($file = readdir($dh)) !== false)
        if(($file != '.') && ($file != '..'))
          if(!is_dir($file) && (strtolower(array_pop(explode(".", $file))) == "php")){
            include($DevFmt_Config['geshilangpath']."/".$file);
            if(isset($language_data)){
              $NewSuppLangs[] = Array($language_data['LANG_NAME'], $file);
              unset($language_data);
            }
          }

    $wpdb->query("DELETE from `{$table_prefix}devfmt_supplangs`");
    foreach($NewSuppLangs as $lang){
      $wpdb->query("insert into `{$table_prefix}devfmt_supplangs` (`langname`,`langfile`,`fav`) ".
        "values ('".$lang[0]."','".$lang[1]."','0');");
    }
    devfmt_ReadSupportedLangs();
  }

  function devfmt_ReadConfigAndLangs(){
    devfmt_ReadConfig();
    devfmt_ReadSupportedLangs();
  }

  function devfmt_saveContent(&$AContent, $AFormatedArea){
    $FormatedAreas = array(uniqid(''), $AFormatedArea);
    while(preg_match("#".$AFormatedArea."#s", $AContent, $matches)){
      array_shift($matches);
      $FormatedAreas[] = $matches;
      $AContent = preg_replace("#".$AFormatedArea."#s", $FormatedAreas[0].(Count($FormatedAreas) - 2)." ", $AContent, 1);
    }
    return $FormatedAreas;
  }

  function devfmt_recoverContent(&$AContent, $AFormatedAreas){
    for($i = 2; $i < Count($AFormatedAreas); $i++){
      while(preg_match("#".$AFormatedAreas[0].($i - 1)." #", $AContent, $matches)){
        $formated = $AFormatedAreas[1];
        foreach($AFormatedAreas[$i] as $tmp)
          $formated = preg_replace("#\(.*?\)#", $tmp, $formated, 1);

        $AContent =  preg_replace("#".$AFormatedAreas[0].($i - 1)." #", $formated, $AContent, 1);
      }
    }
  }

  function devfmt_getLangTitle($ALang){
    GLOBAL $DevFmt_SuppLangs;
    foreach($DevFmt_SuppLangs as $Lang)
      if(strtolower($Lang['langfile']) == $ALang.".php")
        return $Lang['langname'];
    return "unknow";
  }

  function devfmt_RunDefaultFilters($AFilter, $AContent, $ACheckAvoid){
    GLOBAL $DefaultFilters, $DevFmt_FiltersToAvoid;
    foreach($DefaultFilters[$AFilter] as $key => $FilterGroup)
      foreach($FilterGroup as $FilterName => $FilterData){
        $canAdd = true;
        if($ACheckAvoid)
          $canAdd = !array_search($FilterName, $DevFmt_FiltersToAvoid);
        if($canAdd)
          if(!is_null($FilterData['function']))
            $AContent = call_user_func_array($FilterData['function'], Array($AContent));
      }
    return $AContent;
  }

?>
