<?php
/*
Developer Formater
http://wordpress.org/extend/plugins/devformatter/
Developer Formatter system to WordPress. Powered by <a href="http://qbnz.com/highlighter/">GeSHi</a> server-side highlight system.
Version: 2009.0.1.21
Author: Gilberto Saraiva
Author URI: http://gsaraiva.projects.pro.br/

Copyright (c) 2009 Gilberto Saraiva
Released under the GNU General Public License (GPL)
http://www.gnu.org/licenses/gpl.txt
*/

  function devfmt_createTables(){
  	GLOBAL $DevFmt_Config, $DevFmt_SuppLangs, $table_prefix, $wpdb;

    $IsUpgrade = $wpdb->get_var("show tables like '".$table_prefix."devfmt_config'") != "";
    $sqlDevFmtConfig = "CREATE TABLE {$table_prefix}devfmt_config (
      geshilangpath varchar(255) CHARACTER SET utf8 NOT NULL,
      geshiuselink tinyint(1) NOT NULL DEFAULT '0',
      displaylinenumbers tinyint(1) NOT NULL DEFAULT '1',
      usedevformat tinyint(1) NOT NULL DEFAULT '1',
      devfmtcss text CHARACTER SET utf8,
      linkjquery tinyint(1) DEFAULT '1',
      highlighttags tinyint(1) DEFAULT '0',
      copyclipboartext varchar(100) CHARACTER SET utf8 DEFAULT NULL,
      parsepre tinyint(1) DEFAULT '1',
      hookrss2 tinyint(1) DEFAULT '1',
      devversion varchar(30) CHARACTER SET utf8
    );";

    $sqlSupportedLangs = "CREATE TABLE {$table_prefix}devfmt_supplangs (
      langname varchar(100) CHARACTER SET utf8 NOT NULL,
      langfile varchar(100) CHARACTER SET utf8 NOT NULL,
      fav tinyint(1) DEFAULT '0',
      PRIMARY KEY (langname, langfile)
    );";

    if($IsUpgrade){
      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      dbDelta($sqlDevFmtConfig);
      dbDelta($sqlSupportedLangs);

      $curVersion = devfmt_Version($wpdb->get_var("SELECT `devversion` from `{$table_prefix}devfmt_config`"));
      if($curVersion < 2009000001017){
        $IsUpgrade = false;
      }
    }

    if(!$IsUpgrade){
      $wpdb->query($sqlDevFmtConfig);
      $wpdb->query($sqlSupportedLangs);

      $DevFmt_Config['devfmtcss'] = devfmt_DefaultPublicCSSBlue();

      $DevFmt_Config['copyclipboartext'] = 'copy code';
      $DevFmt_Config['geshilangpath'] = DEVFMT_GESHIPATH;
      if(DIRECTORY_SEPARATOR == '\\'){ // win server
        $DevFmt_Config['geshilangpath'] = str_replace('|', '\\\\',
          str_replace('\\', '|', $DevFmt_Config['geshilangpath']));
      }

      $Insert = array("devversion" => devfmt_Version());
      foreach($DevFmt_Config as $field => $value)
        $Insert[$field] = $value;

      $wpdb->query("INSERT INTO {$table_prefix}devfmt_config ".
        "(`".implode("`,`", array_keys($Insert))."`) values ('".implode("','",array_values($Insert))."')");

      devfmt_UpdateConfig();
      devfmt_UpdateSupportedLangs();
    }
  }

  function devfmt_HookFilter($AFilterName){
    GLOBAL $DefaultFilters, $wp_filter;
    $DefaultFilters[$AFilterName] = $wp_filter[$AFilterName];
    $wp_filter[$AFilterName] = Array();
    add_filter($AFilterName, 'devfmt_Formatter_'.$AFilterName);
  }

  function devfmt_Install(){
    register_activation_hook(DEVFMT_PATH.'devformatter.php', 'devfmt_createTables');
    add_filter('tiny_mce_before_init', 'devfmt_addExtendsToMCE');
    add_action('init', 'devfmt_addInterface');
    add_action('admin_head', 'devfmt_adminHeader');
    add_action('admin_menu', 'devfmt_addPages');
    add_action('the_editor', 'devfmt_initEditor');
    add_action('richedit_pre', 'devfmt_rollbackFormat');

    devfmt_HookFilter('the_content');
    devfmt_HookFilter('comment_text');
    devfmt_HookFilter('the_excerpt');

    devfmt_HookFilter('the_content_rss');
    devfmt_HookFilter('comment_text_rss');
    devfmt_HookFilter('the_excerpt_rss');

    add_action('wp_head', 'devfmt_publicHeader');
  }
?>
